Commit | Line | Data |
---|---|---|
e1970ce4 JH |
1 | #!/bin/sh |
2 | # | |
3 | # Copyright (c) 2005 Junio C Hamano | |
4 | # | |
5 | ||
44138559 JS |
6 | # if --tee was passed, write the output not only to the terminal, but |
7 | # additionally to the file test-results/$BASENAME.out, too. | |
8 | case "$GIT_TEST_TEE_STARTED, $* " in | |
9 | done,*) | |
10 | # do not redirect again | |
11 | ;; | |
3da93652 | 12 | *' --tee '*|*' --va'*) |
44138559 JS |
13 | mkdir -p test-results |
14 | BASE=test-results/$(basename "$0" .sh) | |
15 | (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1; | |
16 | echo $? > $BASE.exit) | tee $BASE.out | |
17 | test "$(cat $BASE.exit)" = 0 | |
18 | exit | |
19 | ;; | |
20 | esac | |
21 | ||
c2116a17 JH |
22 | # Keep the original TERM for say_color |
23 | ORIGINAL_TERM=$TERM | |
24 | ||
e1970ce4 JH |
25 | # For repeatability, reset the environment to known value. |
26 | LANG=C | |
899460f3 | 27 | LC_ALL=C |
d9bdd39e | 28 | PAGER=cat |
e1970ce4 | 29 | TZ=UTC |
c2116a17 JH |
30 | TERM=dumb |
31 | export LANG LC_ALL PAGER TERM TZ | |
8ff99e74 EW |
32 | EDITOR=: |
33 | VISUAL=: | |
18508c39 | 34 | unset GIT_EDITOR |
e1970ce4 JH |
35 | unset AUTHOR_DATE |
36 | unset AUTHOR_EMAIL | |
37 | unset AUTHOR_NAME | |
38 | unset COMMIT_AUTHOR_EMAIL | |
39 | unset COMMIT_AUTHOR_NAME | |
28a94f88 | 40 | unset EMAIL |
e1970ce4 JH |
41 | unset GIT_ALTERNATE_OBJECT_DIRECTORIES |
42 | unset GIT_AUTHOR_DATE | |
29e55cd5 JH |
43 | GIT_AUTHOR_EMAIL=author@example.com |
44 | GIT_AUTHOR_NAME='A U Thor' | |
6677c466 | 45 | unset GIT_COMMITTER_DATE |
29e55cd5 JH |
46 | GIT_COMMITTER_EMAIL=committer@example.com |
47 | GIT_COMMITTER_NAME='C O Mitter' | |
e1970ce4 JH |
48 | unset GIT_DIFF_OPTS |
49 | unset GIT_DIR | |
892c41b9 | 50 | unset GIT_WORK_TREE |
e1970ce4 JH |
51 | unset GIT_EXTERNAL_DIFF |
52 | unset GIT_INDEX_FILE | |
53 | unset GIT_OBJECT_DIRECTORY | |
0454dd93 | 54 | unset GIT_CEILING_DIRECTORIES |
e1970ce4 JH |
55 | unset SHA1_FILE_DIRECTORIES |
56 | unset SHA1_FILE_DIRECTORY | |
8d0fc48f SP |
57 | GIT_MERGE_VERBOSITY=5 |
58 | export GIT_MERGE_VERBOSITY | |
29e55cd5 JH |
59 | export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME |
60 | export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME | |
8ff99e74 | 61 | export EDITOR VISUAL |
82ebb0b6 | 62 | GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u} |
e1970ce4 | 63 | |
886a3907 JH |
64 | # Protect ourselves from common misconfiguration to export |
65 | # CDPATH into the environment | |
66 | unset CDPATH | |
67 | ||
3d5c0cc9 | 68 | case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in |
6ce4e61f CC |
69 | 1|2|true) |
70 | echo "* warning: Some tests will not work if GIT_TRACE" \ | |
71 | "is set as to trace on STDERR ! *" | |
72 | echo "* warning: Please set GIT_TRACE to something" \ | |
73 | "other than 1, 2 or true ! *" | |
74 | ;; | |
75 | esac | |
76 | ||
e1970ce4 JH |
77 | # Each test should start with something like this, after copyright notices: |
78 | # | |
79 | # test_description='Description of this test... | |
80 | # This test checks if command xyzzy does the right thing... | |
81 | # ' | |
82 | # . ./test-lib.sh | |
c2116a17 JH |
83 | [ "x$ORIGINAL_TERM" != "xdumb" ] && ( |
84 | TERM=$ORIGINAL_TERM && | |
85 | export TERM && | |
86 | [ -t 1 ] && | |
87 | tput bold >/dev/null 2>&1 && | |
88 | tput setaf 1 >/dev/null 2>&1 && | |
89 | tput sgr0 >/dev/null 2>&1 | |
90 | ) && | |
55db1df0 | 91 | color=t |
e1970ce4 | 92 | |
e1970ce4 JH |
93 | while test "$#" -ne 0 |
94 | do | |
95 | case "$1" in | |
96 | -d|--d|--de|--deb|--debu|--debug) | |
97 | debug=t; shift ;; | |
886856ab JH |
98 | -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate) |
99 | immediate=t; shift ;; | |
5e2c08c6 | 100 | -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests) |
91e80b98 | 101 | GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;; |
e1970ce4 | 102 | -h|--h|--he|--hel|--help) |
570f3226 | 103 | help=t; shift ;; |
e1970ce4 JH |
104 | -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose) |
105 | verbose=t; shift ;; | |
1ece1274 PH |
106 | -q|--q|--qu|--qui|--quie|--quiet) |
107 | quiet=t; shift ;; | |
55db1df0 | 108 | --no-color) |
faa4bc35 | 109 | color=; shift ;; |
abb7c7b3 | 110 | --no-python) |
7cdbff14 JH |
111 | # noop now... |
112 | shift ;; | |
4e1be63c | 113 | --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind) |
3da93652 | 114 | valgrind=t; verbose=t; shift ;; |
44138559 JS |
115 | --tee) |
116 | shift ;; # was handled already | |
f423ef5f JK |
117 | --root=*) |
118 | root=$(expr "z$1" : 'z[^=]*=\(.*\)') | |
119 | shift ;; | |
e1970ce4 | 120 | *) |
1f729dca | 121 | echo "error: unknown test option '$1'" >&2; exit 1 ;; |
e1970ce4 JH |
122 | esac |
123 | done | |
124 | ||
55db1df0 PH |
125 | if test -n "$color"; then |
126 | say_color () { | |
c2116a17 JH |
127 | ( |
128 | TERM=$ORIGINAL_TERM | |
129 | export TERM | |
55db1df0 PH |
130 | case "$1" in |
131 | error) tput bold; tput setaf 1;; # bold red | |
132 | skip) tput bold; tput setaf 2;; # bold green | |
133 | pass) tput setaf 2;; # green | |
134 | info) tput setaf 3;; # brown | |
1ece1274 | 135 | *) test -n "$quiet" && return;; |
55db1df0 PH |
136 | esac |
137 | shift | |
72d404de | 138 | printf "* %s" "$*" |
55db1df0 | 139 | tput sgr0 |
b8eecafd | 140 | echo |
c2116a17 | 141 | ) |
55db1df0 PH |
142 | } |
143 | else | |
144 | say_color() { | |
1ece1274 | 145 | test -z "$1" && test -n "$quiet" && return |
55db1df0 PH |
146 | shift |
147 | echo "* $*" | |
148 | } | |
149 | fi | |
150 | ||
151 | error () { | |
152 | say_color error "error: $*" | |
6e7b5aaf | 153 | GIT_EXIT_OK=t |
55db1df0 PH |
154 | exit 1 |
155 | } | |
156 | ||
157 | say () { | |
158 | say_color info "$*" | |
159 | } | |
160 | ||
570f3226 MB |
161 | test "${test_description}" != "" || |
162 | error "Test script did not set test_description." | |
163 | ||
164 | if test "$help" = "t" | |
165 | then | |
166 | echo "$test_description" | |
167 | exit 0 | |
168 | fi | |
169 | ||
4d9d62fa | 170 | exec 5>&1 |
e1970ce4 JH |
171 | if test "$verbose" = "t" |
172 | then | |
173 | exec 4>&2 3>&1 | |
174 | else | |
175 | exec 4>/dev/null 3>/dev/null | |
176 | fi | |
177 | ||
178 | test_failure=0 | |
179 | test_count=0 | |
41ac414e JH |
180 | test_fixed=0 |
181 | test_broken=0 | |
2d84e9fb | 182 | test_success=0 |
e1970ce4 | 183 | |
faa4bc35 | 184 | die () { |
6e7b5aaf CB |
185 | code=$? |
186 | if test -n "$GIT_EXIT_OK" | |
187 | then | |
188 | exit $code | |
189 | else | |
190 | echo >&5 "FATAL: Unexpected exit with code $code" | |
191 | exit 1 | |
192 | fi | |
faa4bc35 CB |
193 | } |
194 | ||
6e7b5aaf | 195 | GIT_EXIT_OK= |
35641310 | 196 | trap 'die' EXIT |
41184273 | 197 | |
02b35660 BD |
198 | # The semantics of the editor variables are that of invoking |
199 | # sh -c "$EDITOR \"$@\"" files ... | |
200 | # | |
201 | # If our trash directory contains shell metacharacters, they will be | |
202 | # interpreted if we just set $EDITOR directly, so do a little dance with | |
203 | # environment variables to work around this. | |
204 | # | |
205 | # In particular, quoting isn't enough, as the path may contain the same quote | |
7b7b4516 | 206 | # that we're using. |
02b35660 BD |
207 | test_set_editor () { |
208 | FAKE_EDITOR="$1" | |
209 | export FAKE_EDITOR | |
210 | VISUAL='"$FAKE_EDITOR"' | |
211 | export VISUAL | |
212 | } | |
213 | ||
04509738 JH |
214 | test_tick () { |
215 | if test -z "${test_tick+set}" | |
216 | then | |
21afc41c | 217 | test_tick=1112911993 |
04509738 JH |
218 | else |
219 | test_tick=$(($test_tick + 60)) | |
220 | fi | |
21afc41c JH |
221 | GIT_COMMITTER_DATE="$test_tick -0700" |
222 | GIT_AUTHOR_DATE="$test_tick -0700" | |
04509738 JH |
223 | export GIT_COMMITTER_DATE GIT_AUTHOR_DATE |
224 | } | |
e1970ce4 | 225 | |
00884968 JS |
226 | # Call test_commit with the arguments "<message> [<file> [<contents>]]" |
227 | # | |
228 | # This will commit a file with the given contents and the given commit | |
229 | # message. It will also add a tag with <message> as name. | |
230 | # | |
231 | # Both <file> and <contents> default to <message>. | |
232 | ||
233 | test_commit () { | |
e656fc97 | 234 | file=${2:-"$1.t"} |
00884968 JS |
235 | echo "${3-$1}" > "$file" && |
236 | git add "$file" && | |
237 | test_tick && | |
238 | git commit -m "$1" && | |
239 | git tag "$1" | |
240 | } | |
241 | ||
242 | # Call test_merge with the arguments "<message> <commit>", where <commit> | |
243 | # can be a tag pointing to the commit-to-merge. | |
244 | ||
245 | test_merge () { | |
246 | test_tick && | |
247 | git merge -m "$1" "$2" && | |
248 | git tag "$1" | |
249 | } | |
250 | ||
1f553918 JS |
251 | # This function helps systems where core.filemode=false is set. |
252 | # Use it instead of plain 'chmod +x' to set or unset the executable bit | |
253 | # of a file in the working directory and add it to the index. | |
254 | ||
255 | test_chmod () { | |
256 | chmod "$@" && | |
257 | git update-index --add "--chmod=$@" | |
258 | } | |
259 | ||
a7bb3940 JS |
260 | # Use test_set_prereq to tell that a particular prerequisite is available. |
261 | # The prerequisite can later be checked for in two ways: | |
262 | # | |
263 | # - Explicitly using test_have_prereq. | |
264 | # | |
265 | # - Implicitly by specifying the prerequisite tag in the calls to | |
266 | # test_expect_{success,failure,code}. | |
267 | # | |
268 | # The single parameter is the prerequisite tag (a simple word, in all | |
269 | # capital letters by convention). | |
270 | ||
271 | test_set_prereq () { | |
272 | satisfied="$satisfied$1 " | |
273 | } | |
274 | satisfied=" " | |
275 | ||
276 | test_have_prereq () { | |
277 | case $satisfied in | |
278 | *" $1 "*) | |
279 | : yes, have it ;; | |
280 | *) | |
281 | ! : nope ;; | |
282 | esac | |
283 | } | |
284 | ||
886856ab JH |
285 | # You are not expected to call test_ok_ and test_failure_ directly, use |
286 | # the text_expect_* functions instead. | |
287 | ||
288 | test_ok_ () { | |
d5d9de1b | 289 | test_success=$(($test_success + 1)) |
55db1df0 | 290 | say_color "" " ok $test_count: $@" |
e1970ce4 JH |
291 | } |
292 | ||
886856ab | 293 | test_failure_ () { |
d5d9de1b | 294 | test_failure=$(($test_failure + 1)) |
55db1df0 | 295 | say_color error "FAIL $test_count: $1" |
bf0dd8a8 JH |
296 | shift |
297 | echo "$@" | sed -e 's/^/ /' | |
6e7b5aaf | 298 | test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; } |
886856ab JH |
299 | } |
300 | ||
41ac414e | 301 | test_known_broken_ok_ () { |
41ac414e JH |
302 | test_fixed=$(($test_fixed+1)) |
303 | say_color "" " FIXED $test_count: $@" | |
304 | } | |
305 | ||
306 | test_known_broken_failure_ () { | |
41ac414e JH |
307 | test_broken=$(($test_broken+1)) |
308 | say_color skip " still broken $test_count: $@" | |
309 | } | |
886856ab JH |
310 | |
311 | test_debug () { | |
8e832ebc | 312 | test "$debug" = "" || eval "$1" |
e1970ce4 JH |
313 | } |
314 | ||
4d9d62fa | 315 | test_run_ () { |
4d9d62fa PR |
316 | eval >&3 2>&4 "$1" |
317 | eval_ret="$?" | |
4d9d62fa PR |
318 | return 0 |
319 | } | |
320 | ||
04ece593 | 321 | test_skip () { |
8586f98b | 322 | test_count=$(($test_count+1)) |
04ece593 JH |
323 | to_skip= |
324 | for skp in $GIT_SKIP_TESTS | |
325 | do | |
8586f98b | 326 | case $this_test.$test_count in |
04ece593 JH |
327 | $skp) |
328 | to_skip=t | |
329 | esac | |
330 | done | |
a7bb3940 JS |
331 | if test -z "$to_skip" && test -n "$prereq" && |
332 | ! test_have_prereq "$prereq" | |
333 | then | |
334 | to_skip=t | |
335 | fi | |
04ece593 JH |
336 | case "$to_skip" in |
337 | t) | |
55db1df0 | 338 | say_color skip >&3 "skipping test: $@" |
55db1df0 | 339 | say_color skip "skip $test_count: $1" |
04ece593 JH |
340 | : true |
341 | ;; | |
342 | *) | |
343 | false | |
344 | ;; | |
345 | esac | |
346 | } | |
347 | ||
e1970ce4 | 348 | test_expect_failure () { |
a7bb3940 | 349 | test "$#" = 3 && { prereq=$1; shift; } || prereq= |
8e832ebc | 350 | test "$#" = 2 || |
a7bb3940 | 351 | error "bug in the test script: not 2 or 3 parameters to test-expect-failure" |
04ece593 | 352 | if ! test_skip "$@" |
e1970ce4 | 353 | then |
41ac414e | 354 | say >&3 "checking known breakage: $2" |
04ece593 | 355 | test_run_ "$2" |
41ac414e | 356 | if [ "$?" = 0 -a "$eval_ret" = 0 ] |
04ece593 | 357 | then |
41ac414e | 358 | test_known_broken_ok_ "$1" |
04ece593 | 359 | else |
6e7b5aaf | 360 | test_known_broken_failure_ "$1" |
04ece593 | 361 | fi |
e1970ce4 | 362 | fi |
7a0cf2d0 | 363 | echo >&3 "" |
e1970ce4 JH |
364 | } |
365 | ||
366 | test_expect_success () { | |
a7bb3940 | 367 | test "$#" = 3 && { prereq=$1; shift; } || prereq= |
8e832ebc | 368 | test "$#" = 2 || |
a7bb3940 | 369 | error "bug in the test script: not 2 or 3 parameters to test-expect-success" |
04ece593 | 370 | if ! test_skip "$@" |
e1970ce4 | 371 | then |
04ece593 JH |
372 | say >&3 "expecting success: $2" |
373 | test_run_ "$2" | |
374 | if [ "$?" = 0 -a "$eval_ret" = 0 ] | |
375 | then | |
376 | test_ok_ "$1" | |
377 | else | |
378 | test_failure_ "$@" | |
379 | fi | |
e1970ce4 | 380 | fi |
7a0cf2d0 | 381 | echo >&3 "" |
e1970ce4 JH |
382 | } |
383 | ||
d3bfdb75 | 384 | test_expect_code () { |
a7bb3940 | 385 | test "$#" = 4 && { prereq=$1; shift; } || prereq= |
d3bfdb75 | 386 | test "$#" = 3 || |
a7bb3940 | 387 | error "bug in the test script: not 3 or 4 parameters to test-expect-code" |
04ece593 | 388 | if ! test_skip "$@" |
d3bfdb75 | 389 | then |
04ece593 JH |
390 | say >&3 "expecting exit code $1: $3" |
391 | test_run_ "$3" | |
392 | if [ "$?" = 0 -a "$eval_ret" = "$1" ] | |
393 | then | |
394 | test_ok_ "$2" | |
395 | else | |
396 | test_failure_ "$@" | |
397 | fi | |
d3bfdb75 | 398 | fi |
7a0cf2d0 | 399 | echo >&3 "" |
d3bfdb75 FK |
400 | } |
401 | ||
fb32c410 LW |
402 | # test_external runs external test scripts that provide continuous |
403 | # test output about their progress, and succeeds/fails on | |
404 | # zero/non-zero exit code. It outputs the test output on stdout even | |
405 | # in non-verbose mode, and announces the external script with "* run | |
406 | # <n>: ..." before running it. When providing relative paths, keep in | |
407 | # mind that all scripts run in "trash directory". | |
408 | # Usage: test_external description command arguments... | |
409 | # Example: test_external 'Perl API' perl ../path/to/test.pl | |
410 | test_external () { | |
a7bb3940 JS |
411 | test "$#" = 4 && { prereq=$1; shift; } || prereq= |
412 | test "$#" = 3 || | |
413 | error >&5 "bug in the test script: not 3 or 4 parameters to test_external" | |
fb32c410 LW |
414 | descr="$1" |
415 | shift | |
416 | if ! test_skip "$descr" "$@" | |
417 | then | |
418 | # Announce the script to reduce confusion about the | |
419 | # test output that follows. | |
8586f98b | 420 | say_color "" " run $test_count: $descr ($*)" |
fb32c410 LW |
421 | # Run command; redirect its stderr to &4 as in |
422 | # test_run_, but keep its stdout on our stdout even in | |
423 | # non-verbose mode. | |
424 | "$@" 2>&4 | |
425 | if [ "$?" = 0 ] | |
426 | then | |
427 | test_ok_ "$descr" | |
428 | else | |
429 | test_failure_ "$descr" "$@" | |
430 | fi | |
431 | fi | |
432 | } | |
433 | ||
434 | # Like test_external, but in addition tests that the command generated | |
435 | # no output on stderr. | |
436 | test_external_without_stderr () { | |
437 | # The temporary file has no (and must have no) security | |
438 | # implications. | |
439 | tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi | |
440 | stderr="$tmp/git-external-stderr.$$.tmp" | |
441 | test_external "$@" 4> "$stderr" | |
442 | [ -f "$stderr" ] || error "Internal error: $stderr disappeared." | |
443 | descr="no stderr: $1" | |
444 | shift | |
445 | say >&3 "expecting no stderr from previous command" | |
446 | if [ ! -s "$stderr" ]; then | |
447 | rm "$stderr" | |
448 | test_ok_ "$descr" | |
449 | else | |
450 | if [ "$verbose" = t ]; then | |
451 | output=`echo; echo Stderr is:; cat "$stderr"` | |
452 | else | |
453 | output= | |
454 | fi | |
455 | # rm first in case test_failure exits. | |
456 | rm "$stderr" | |
457 | test_failure_ "$descr" "$@" "$output" | |
458 | fi | |
459 | } | |
460 | ||
74359821 JH |
461 | # This is not among top-level (test_expect_success | test_expect_failure) |
462 | # but is a prefix that can be used in the test script, like: | |
463 | # | |
464 | # test_expect_success 'complain and die' ' | |
465 | # do something && | |
466 | # do something else && | |
467 | # test_must_fail git checkout ../outerspace | |
468 | # ' | |
469 | # | |
470 | # Writing this as "! git checkout ../outerspace" is wrong, because | |
471 | # the failure could be due to a segv. We want a controlled failure. | |
472 | ||
473 | test_must_fail () { | |
474 | "$@" | |
5a269730 | 475 | test $? -gt 0 -a $? -le 129 -o $? -gt 192 |
74359821 JH |
476 | } |
477 | ||
82ebb0b6 JK |
478 | # test_cmp is a helper function to compare actual and expected output. |
479 | # You can use it like: | |
480 | # | |
481 | # test_expect_success 'foo works' ' | |
482 | # echo expected >expected && | |
483 | # foo >actual && | |
484 | # test_cmp expected actual | |
485 | # ' | |
486 | # | |
487 | # This could be written as either "cmp" or "diff -u", but: | |
488 | # - cmp's output is not nearly as easy to read as diff -u | |
489 | # - not all diff versions understand "-u" | |
490 | ||
491 | test_cmp() { | |
492 | $GIT_TEST_CMP "$@" | |
493 | } | |
494 | ||
0509eb21 | 495 | # Most tests can use the created repository, but some may need to create more. |
eedf8f97 CW |
496 | # Usage: test_create_repo <directory> |
497 | test_create_repo () { | |
498 | test "$#" = 1 || | |
499 | error "bug in the test script: not 1 parameter to test-create-repo" | |
500 | owd=`pwd` | |
501 | repo="$1" | |
bfdbee98 | 502 | mkdir -p "$repo" |
eedf8f97 | 503 | cd "$repo" || error "Cannot setup test environment" |
3a048328 | 504 | "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 || |
5c94f87e | 505 | error "cannot run git init -- have you built things yet?" |
eedf8f97 CW |
506 | mv .git/hooks .git/hooks-disabled |
507 | cd "$owd" | |
508 | } | |
a6080a0a | 509 | |
e1970ce4 | 510 | test_done () { |
6e7b5aaf | 511 | GIT_EXIT_OK=t |
2d84e9fb SR |
512 | test_results_dir="$TEST_DIRECTORY/test-results" |
513 | mkdir -p "$test_results_dir" | |
bba2a7b2 | 514 | test_results_path="$test_results_dir/${0%.sh}-$$" |
2d84e9fb SR |
515 | |
516 | echo "total $test_count" >> $test_results_path | |
517 | echo "success $test_success" >> $test_results_path | |
518 | echo "fixed $test_fixed" >> $test_results_path | |
519 | echo "broken $test_broken" >> $test_results_path | |
520 | echo "failed $test_failure" >> $test_results_path | |
521 | echo "" >> $test_results_path | |
41ac414e JH |
522 | |
523 | if test "$test_fixed" != 0 | |
524 | then | |
525 | say_color pass "fixed $test_fixed known breakage(s)" | |
526 | fi | |
527 | if test "$test_broken" != 0 | |
528 | then | |
529 | say_color error "still have $test_broken known breakage(s)" | |
11d54b8b JH |
530 | msg="remaining $(($test_count-$test_broken)) test(s)" |
531 | else | |
532 | msg="$test_count test(s)" | |
41ac414e | 533 | fi |
e1970ce4 | 534 | case "$test_failure" in |
10b94e28 | 535 | 0) |
11d54b8b | 536 | say_color pass "passed all $msg" |
abc5d372 JS |
537 | |
538 | test -d "$remove_trash" && | |
539 | cd "$(dirname "$remove_trash")" && | |
540 | rm -rf "$(basename "$remove_trash")" | |
541 | ||
e1970ce4 JH |
542 | exit 0 ;; |
543 | ||
544 | *) | |
11d54b8b | 545 | say_color error "failed $test_failure among $msg" |
e1970ce4 JH |
546 | exit 1 ;; |
547 | ||
548 | esac | |
549 | } | |
550 | ||
551 | # Test the binaries we have just built. The tests are kept in | |
9adefee5 | 552 | # t/ subdirectory and are run in 'trash directory' subdirectory. |
2d84e9fb | 553 | TEST_DIRECTORY=$(pwd) |
4e1be63c JS |
554 | if test -z "$valgrind" |
555 | then | |
6720721e MG |
556 | if test -z "$GIT_TEST_INSTALLED" |
557 | then | |
558 | PATH=$TEST_DIRECTORY/..:$PATH | |
559 | GIT_EXEC_PATH=$TEST_DIRECTORY/.. | |
560 | else | |
561 | GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) || | |
562 | error "Cannot run git from $GIT_TEST_INSTALLED." | |
563 | PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH | |
564 | GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH} | |
565 | fi | |
4e1be63c JS |
566 | else |
567 | make_symlink () { | |
568 | test -h "$2" && | |
569 | test "$1" = "$(readlink "$2")" || { | |
570 | # be super paranoid | |
571 | if mkdir "$2".lock | |
572 | then | |
573 | rm -f "$2" && | |
574 | ln -s "$1" "$2" && | |
575 | rm -r "$2".lock | |
576 | else | |
577 | while test -d "$2".lock | |
578 | do | |
579 | say "Waiting for lock on $2." | |
580 | sleep 1 | |
581 | done | |
582 | fi | |
583 | } | |
584 | } | |
585 | ||
586 | make_valgrind_symlink () { | |
587 | # handle only executables | |
588 | test -x "$1" || return | |
589 | ||
590 | base=$(basename "$1") | |
591 | symlink_target=$TEST_DIRECTORY/../$base | |
592 | # do not override scripts | |
593 | if test -x "$symlink_target" && | |
594 | test ! -d "$symlink_target" && | |
595 | test "#!" != "$(head -c 2 < "$symlink_target")" | |
596 | then | |
597 | symlink_target=../valgrind.sh | |
598 | fi | |
efd92ffd JS |
599 | case "$base" in |
600 | *.sh|*.perl) | |
601 | symlink_target=../unprocessed-script | |
602 | esac | |
4e1be63c JS |
603 | # create the link, or replace it if it is out of date |
604 | make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit | |
605 | } | |
606 | ||
607 | # override all git executables in TEST_DIRECTORY/.. | |
608 | GIT_VALGRIND=$TEST_DIRECTORY/valgrind | |
609 | mkdir -p "$GIT_VALGRIND"/bin | |
610 | for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-* | |
611 | do | |
612 | make_valgrind_symlink $file | |
613 | done | |
efd92ffd JS |
614 | OLDIFS=$IFS |
615 | IFS=: | |
616 | for path in $PATH | |
617 | do | |
618 | ls "$path"/git-* 2> /dev/null | | |
619 | while read file | |
620 | do | |
621 | make_valgrind_symlink "$file" | |
622 | done | |
623 | done | |
624 | IFS=$OLDIFS | |
4e1be63c JS |
625 | PATH=$GIT_VALGRIND/bin:$PATH |
626 | GIT_EXEC_PATH=$GIT_VALGRIND/bin | |
627 | export GIT_VALGRIND | |
4e1be63c | 628 | fi |
8683a45d | 629 | GIT_TEMPLATE_DIR=$(pwd)/../templates/blt |
8bfa6bd6 | 630 | unset GIT_CONFIG |
8bfa6bd6 JK |
631 | GIT_CONFIG_NOSYSTEM=1 |
632 | GIT_CONFIG_NOGLOBAL=1 | |
633 | export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL | |
49ccb087 | 634 | |
6fcca938 PB |
635 | GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git |
636 | export GITPERLLIB | |
eea42069 JH |
637 | test -d ../templates/blt || { |
638 | error "You haven't built things yet, have you?" | |
639 | } | |
e1970ce4 | 640 | |
56cf9806 EW |
641 | if ! test -x ../test-chmtime; then |
642 | echo >&2 'You need to build test-chmtime:' | |
643 | echo >&2 'Run "make test-chmtime" in the source (toplevel) directory' | |
644 | exit 1 | |
645 | fi | |
646 | ||
7cf7f54a JK |
647 | . ../GIT-BUILD-OPTIONS |
648 | ||
e1970ce4 | 649 | # Test repository |
abc5d372 | 650 | test="trash directory.$(basename "$0" .sh)" |
f423ef5f JK |
651 | test -n "$root" && test="$root/$test" |
652 | case "$test" in | |
653 | /*) TRASH_DIRECTORY="$test" ;; | |
654 | *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;; | |
655 | esac | |
91c8b825 | 656 | test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY |
8d14ac94 | 657 | rm -fr "$test" || { |
6e7b5aaf | 658 | GIT_EXIT_OK=t |
8d14ac94 JH |
659 | echo >&5 "FATAL: Cannot prepare test area" |
660 | exit 1 | |
661 | } | |
662 | ||
4a7aaccd | 663 | test_create_repo "$test" |
1bd9c648 LW |
664 | # Use -P to resolve symlinks in our working directory so that the cwd |
665 | # in subprocesses like git equals our $PWD (for pathname comparisons). | |
666 | cd -P "$test" || exit 1 | |
04ece593 | 667 | |
d5d9de1b JS |
668 | this_test=${0##*/} |
669 | this_test=${this_test%%-*} | |
04ece593 JH |
670 | for skp in $GIT_SKIP_TESTS |
671 | do | |
672 | to_skip= | |
673 | for skp in $GIT_SKIP_TESTS | |
674 | do | |
675 | case "$this_test" in | |
676 | $skp) | |
677 | to_skip=t | |
678 | esac | |
679 | done | |
680 | case "$to_skip" in | |
681 | t) | |
55db1df0 PH |
682 | say_color skip >&3 "skipping test $this_test altogether" |
683 | say_color skip "skip all tests in $this_test" | |
04ece593 JH |
684 | test_done |
685 | esac | |
686 | done | |
f17e9fbb JS |
687 | |
688 | # Fix some commands on Windows | |
689 | case $(uname -s) in | |
690 | *MINGW*) | |
691 | # Windows has its own (incompatible) sort and find | |
692 | sort () { | |
693 | /usr/bin/sort "$@" | |
694 | } | |
695 | find () { | |
696 | /usr/bin/find "$@" | |
697 | } | |
5397ea31 JS |
698 | sum () { |
699 | md5sum "$@" | |
700 | } | |
4114156a JS |
701 | # git sees Windows-style pwd |
702 | pwd () { | |
703 | builtin pwd -W | |
704 | } | |
ee9fb68c | 705 | # no POSIX permissions |
6fd1106a | 706 | # backslashes in pathspec are converted to '/' |
fb9a2bea | 707 | # exec does not inherit the PID |
ee9fb68c JS |
708 | ;; |
709 | *) | |
710 | test_set_prereq POSIXPERM | |
6fd1106a | 711 | test_set_prereq BSLASHPSPEC |
fb9a2bea | 712 | test_set_prereq EXECKEEPSPID |
f17e9fbb JS |
713 | ;; |
714 | esac | |
704a3143 | 715 | |
1b19ccd2 JK |
716 | test -z "$NO_PERL" && test_set_prereq PERL |
717 | ||
704a3143 JS |
718 | # test whether the filesystem supports symbolic links |
719 | ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS | |
720 | rm -f y |